function neighbor_id, xi, xt

; S. Baba (20160908)
; This function returns the subscript of the element of a vector xi 
; that has the closest value to the specified value xt.
;
  
  n = n_elements(xi)
  
  if n_elements(uniq(xi)) LT n then message, 'Input 1D array must has unique values.',/continue
  
  srt = sort(xi)
  xi_asc = xi[srt]
  xi_des = xi[reverse(srt)]
  
  ascending  = array_equal(xi,xi_asc)
  descending = array_equal(xi,xi_des)
  
  if ~( ascending || descending ) then message, 'Input 1D array must has ascending or descending order.'
  
  case 1 of
    (xt LT min(xi))||(xt GT max(xi)): message, 'Out of range.'
    (xt EQ xi[0]):   x0 = 0
    (xt EQ xi[n-1]): x0 = n-2
    else: begin
      case 1 of
        ascending: begin
          nega_id = where(xi-xt LT 0.)
          x0 = max(nega_id)
        end
        descending: begin
          posi_id = where(xi-xt GT 0.)
          x0 = max(posi_id)
        end
        else: message, 'Input 1D array must has ascending or descending order.'
      endcase
    end
  endcase
  
  return, [x0,x0+1]

end
