function ng_waveconv, wave_array_1st

; S. Baba (20160908)
; This function converts 1st-order wavelengths to 2nd-order wavelengths.
; (1st-order wavelength -> position on the etector -> 2nd-order wavelength)
; The wavelength calibration curve is shown in Fig. 5 of Baba et al. (2016).
;
; input
;   wave_array_1st: a vector of 1st-order wavelengths
; output
;   wave_array_2nd: a vector of 2nd-order wavelengths
;

  ; read the wavelength calibration curve
  set_wavetable_ng,pos_tab,lambda_1st,lambda_2nd
  
  ; linear interpolation
  linterp,lambda_1st,lambda_2nd,wave_array_1st,wave_array_2nd,MISSING=0.
  
  return, wave_array_2nd
  
end
