pro iispec, targetid, targetsubid, brightest_10_source=brightest_10_source, $
        source_table_offset_x_value=source_table_offset_x_value, $
        source_table_offset_y_value=source_table_offset_y_value, $
        use_short_refimage=use_short_refimage,ds9_edit=ds9_edit,  $
        use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift, $
        Ns_spec=Ns_spec,Nh_spec=Nh_spec,Np_spec=Np_spec,Ls_spec=Ls_spec, Lc_spec=Lc_spec,  $
        MIRS_Ns_spec=MIRS_Ns_spec, MIRS_Nc_spec=MIRS_Nc_spec, $
        wcs=wcs,PV2=PV2,no_database_check=no_database_check, $
        NG=NG, $
        make_4d=make_4d, short_wcs=short_wcs, $
        with_src=with_src, $
        no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
        no_message_window=no_message_window, $
        _EXTRA=EXTRA_KEYWORDS

if N_params() NE 2 then begin
 message,'please give me TID and TIDsub!'
 return
endif

det_pos = 'Nc'
IF keyword_set(Np_spec) THEN det_pos = 'Np' ELSE $
IF keyword_set(Ns_spec) THEN det_pos = 'Ns' ELSE $
IF keyword_set(Nh_spec) THEN det_pos = 'Nh' ELSE $
IF keyword_set(Ls_spec) THEN det_pos = 'Ls'

src_table = ''
IF keyword_set(with_src) THEN src_table = 'src.tbl' 


IF keyword_set(NG) THEN BEGIN 
 irc_specred, targetid, targetsubid, src_table, 'N3.lst', 'NG.lst', 'N3_NG', $
 brightest_10_source=brightest_10_source, Np_spec=Np_spec,  $
 source_table_offset_x_value=source_table_offset_x_value, $
 source_table_offset_y_value=source_table_offset_y_value, $
 use_short_refimage=use_short_refimage,ds9_edit=ds9_edit, $
 use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift,$
 Ns_spec=Ns_spec,Nh_spec=Nh_spec,Ls_spec=Ls_spec, $
 no_database_check=no_database_check, $
 make_4d=make_4d, $
 no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
 no_message_window=no_message_window, $
 _EXTRA=EXTRA_KEYWORDS

ENDIF ELSE BEGIN
   IF keyword_set(MIRS_Ns_spec) THEN BEGIN 
      Ns_spec = 1B
      irc_specred, targetid, targetsubid, src_table, 'S9W.lst', 'SG1.lst', 'S9W_SG1', $
                   brightest_10_source=brightest_10_source, Np_spec=Np_spec,  $
                   source_table_offset_x_value=source_table_offset_x_value, $
                   source_table_offset_y_value=source_table_offset_y_value, $
                   use_short_refimage=use_short_refimage,ds9_edit=ds9_edit, $
                   use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift,$
                   Ns_spec=Ns_spec,Nh_spec=Nh_spec,Ls_spec=Ls_spec, $
                   no_database_check=no_database_check, $
                   make_4d=make_4d, $
                   no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
                   no_message_window=no_message_window, $
                   _EXTRA=EXTRA_KEYWORDS

      irc_specred, targetid, targetsubid, src_table, 'S9W.lst', 'SG2.lst', 'S9W_SG2', $
                   brightest_10_source=brightest_10_source, Np_spec=Np_spec,  $
                   source_table_offset_x_value=source_table_offset_x_value, $
                   source_table_offset_y_value=source_table_offset_y_value, $
                   use_short_refimage=use_short_refimage,ds9_edit=ds9_edit, $
                   use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift,$
                   Ns_spec=Ns_spec,Nh_spec=Nh_spec,Ls_spec=Ls_spec, $
                   no_database_check=no_database_check, $
                   make_4d=make_4d, $
                   no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
                   no_message_window=no_message_window, $
                   _EXTRA=EXTRA_KEYWORDS

      ENDIF ELSE IF keyword_set(MIRS_Nc_spec) THEN BEGIN 

      irc_specred, targetid, targetsubid, src_table, 'S9W.lst', 'SG1.lst', 'S9W_SG1', $
                   brightest_10_source=brightest_10_source, Np_spec=Np_spec,  $
                   source_table_offset_x_value=source_table_offset_x_value, $
                   source_table_offset_y_value=source_table_offset_y_value, $
                   use_short_refimage=use_short_refimage,ds9_edit=ds9_edit, $
                   use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift,$
                   Ns_spec=Ns_spec,Nh_spec=Nh_spec,Ls_spec=Ls_spec, $
                   no_database_check=no_database_check, $
                   make_4d=make_4d, $
                   no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
                   no_message_window=no_message_window, $
                   _EXTRA=EXTRA_KEYWORDS

      IF keyword_set(with_src) THEN src_table = 'src.tbl' 

      irc_specred, targetid, targetsubid, src_table, 'S9W.lst', 'SG2.lst', 'S9W_SG2', $
                   brightest_10_source=brightest_10_source, Np_spec=Np_spec,  $
                   source_table_offset_x_value=source_table_offset_x_value, $
                   source_table_offset_y_value=source_table_offset_y_value, $
                   use_short_refimage=use_short_refimage,ds9_edit=ds9_edit, $
                   use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift,$
                   Ns_spec=Ns_spec,Nh_spec=Nh_spec,Ls_spec=Ls_spec, $
                   no_database_check=no_database_check, $
                   make_4d=make_4d, $
                   no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
                   no_message_window=no_message_window, $
                   _EXTRA=EXTRA_KEYWORDS

   ENDIF ELSE BEGIN
      irc_specred, targetid, targetsubid, src_table, 'N3.lst', 'NP.lst', 'N3_NP', $
                   brightest_10_source=brightest_10_source, $
                   source_table_offset_x_value=source_table_offset_x_value, $
                   source_table_offset_y_value=source_table_offset_y_value, $
                   use_short_refimage=use_short_refimage,ds9_edit=ds9_edit, $
                   use_short_for_wave_offset=use_short_for_wave_offset,use_short_for_calc_x_shift=use_short_for_calc_x_shift,$
                   Ns_spec=Ns_spec,Nh_spec=Nh_spec,Np_spec=Np_spec,Ls_spec=Ls_spec,  $
                   no_database_check=no_database_check,  $
                   make_4d=make_4d, $
                   no_slit_flat=no_slit_flat, no_tune_sourcepos=no_tune_sourcepos, $
                   no_message_window=no_message_window, $
                   _EXTRA=EXTRA_KEYWORDS
      
   ENDELSE
ENDELSE

; Move irc_specred_out to appropriate directory
irc_specred_out_dir = getenv("IRC_SPECRED_DATADIR") + STRTRIM(STRING(targetID),2) +"."+ STRTRIM(STRING(targetsubID),2) +"/irc_specred_out"
new_irc_specred_out_dir = irc_specred_out_dir +"_"+ STRTRIM(det_pos,2)

FILE_DELETE, new_irc_specred_out_dir, /RECURSIVE, /ALLOW_NONEXISTENT
FILE_COPY, irc_specred_out_dir, new_irc_specred_out_dir, /RECURSIVE

print,""
print,"Reduced files are saved in this directory"
print, new_irc_specred_out_dir
print,""

END
