pro iispec_plot, targetid, targetsubid, source_id, root_dir=root_dir, $
  offset_pix=offset_pix, no_mask=no_mask, with_image=with_image, $
  space_shift=space_shift, tvtop=tvtop, tvbottom=tvbottom, PS=PS, PNG=PNG, ascii=ascii, $
  sigma_filter_set=sigma_filter_set, wc_mode=wc_mode,smooth_width=smooth_width, _EXTRA=EXTRA_KEYWORDS, $
  wave_array_shift=wave_array_shift, $
  specimage_wc_1d_smooth=specimage_wc_1d_smooth,specimage_fc_1d_smooth=specimage_fc_1d_smooth, $
  no_wavelength_shift_error=no_wavelength_shift_error, $
  original_plot=original_plot, YSO_dir=YSO_dir, $
  median=median, bg_nsum=bg_nsum, $
  diffuse=diffuse, not_org=not_org, oplot=oplot, $
  over_plot_em=over_plot_em, $
  Nh_sky=Nh_sky, Ns_sky=Ns_sky, $
  NG=NG, $
  SG1=SG1, SG2=SG2, $
  short=short, $
  chk_nsum=chk_nsum, $
  title=title, $
  error_new=error_new



;;; use revised error estimation
;;error_new = 1

  title_id = strtrim(string(targetid),2)+'.'+strtrim(string(targetsubid),2)+'.'+strtrim(string(source_id),2)
  var_file = getenv('IRC_SPECRED_DATADIR') + STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'/irc_specred_out/'+ STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'.N3_NP.IRC_SPECRED_OUT.sav'

IF keyword_set(NG) THEN BEGIN
   NG_2nd_cal=1b
   title_id = strtrim(string(targetid),2)+'.'+strtrim(string(targetsubid),2)+'.'+strtrim(string(source_id),2)
   var_file = getenv('IRC_SPECRED_DATADIR') + STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'/irc_specred_out/'+ STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'.N3_NG.IRC_SPECRED_OUT.sav'
ENDIF ELSE IF keyword_set(SG1) THEN BEGIN
   title_id = strtrim(string(targetid),2)+'.'+strtrim(string(targetsubid),2)+'.'+strtrim(string(source_id),2)
   var_file = getenv('IRC_SPECRED_DATADIR') + STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'/irc_specred_out/'+ STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'.S9W_SG1.IRC_SPECRED_OUT.sav'
ENDIF ELSE IF keyword_set(SG2) THEN BEGIN
   title_id = strtrim(string(targetid),2)+'.'+strtrim(string(targetsubid),2)+'.'+strtrim(string(source_id),2)
   var_file = getenv('IRC_SPECRED_DATADIR') + STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'/irc_specred_out/'+ STRTRIM(STRING(targetid),2) +'.'+ STRTRIM(STRING(targetsubid),2) +'.S9W_SG2.IRC_SPECRED_OUT.sav'
ENDIF

IF ~keyword_set(title) THEN BEGIN
   title = title_id
ENDIF

;Restore variable
;current_path = !PATH
root       = getenv('IRC_SPECRED_ROOT')
lib        = getenv('IRC_SPECRED_LIB')
home       = getenv('IRC_SPECRED_HOME')
calbdir    = getenv('IRC_SPECRED_CALIBDIR')
datadir    = getenv('IRC_SPECRED_DATADIR')

restore,var_file

;;; revised: 151007
!IRC_SPECRED_DIR.datadir  = datadir
!IRC_SPECRED_DIR.calibdir = calbdir

!IRC_SPECRED_DIR.datadir2 = !IRC_SPECRED_DIR.datadir  + strim(targetid) + '.' + strim(targetsubid) + '/rawdata/'
!IRC_SPECRED_DIR.workdir  = !IRC_SPECRED_DIR.datadir2 + '/../irc_specred_out/'
!IRC_SPECRED_DIR.tmpdir   = !IRC_SPECRED_DIR.workdir  + '/tmp/'


IF keyword_set(short) THEN BEGIN
   specimage_n_wc = specimage_n_wc_short * 4.
ENDIF


IF keyword_set(original_plot) THEN BEGIN
   plot_spec_with_image,wave_array,specimage_n_wc,mask_specimage_n,source_table,source_id,  $
   root_dir=root_dir, offset_pix=offset_pix, no_mask=no_mask, with_image=with_image,  $
   space_shift=space_shift, tvtop=tvtop, tvbottom=tvbottom, PS=PS, PNG=PNG, ascii=ascii, smooth_width=smooth_width, $
   specimage_wc_1d_smooth=specimage_wc_1d_smooth,specimage_fc_1d_smooth=specimage_fc_1d_smooth, $
   no_wavelength_shift_error=no_wavelength_shift_error, $
   sigma_filter_set=sigma_filter_set, wc_mode=wc_mode, $
   median=median, bg_nsum=bg_nsum, oplot=oplot, $
   error_new=error_new, $
   NG_2nd_cal=NG_2nd_cal, $
   _EXTRA=EXTRA_KEYWORDS
ENDIF ELSE BEGIN

   IF keyword_set(chk_nsum) THEN BEGIN
      print,'Output ASCII spectra as test.nsum=***'

        for ii=3, 15, 2 do begin
           ASCII = 'test.nsum='+ string(ii, format='(i0)')
           plot_spec_with_image,wave_array,specimage_n_wc,mask_specimage_n,source_table,source_id,  $
                                root_dir=root_dir, offset_pix=offset_pix, no_mask=no_mask, with_image=with_image,  $
                                space_shift=space_shift, tvtop=tvtop, tvbottom=tvbottom, PS=PS, PNG=PNG, ascii=ascii, smooth_width=smooth_width, $
                                sigma_filter_set=sigma_filter_set, wc_mode=wc_mode, _EXTRA=EXTRA_KEYWORDS, $
                                specimage_wc_1d_smooth=specimage_wc_1d_smooth,specimage_fc_1d_smooth=specimage_fc_1d_smooth, $
                                no_wavelength_shift_error=no_wavelength_shift_error, $
                                title=title,subtitle=subtitle,charthick=2,charsize=2,xthick=2,ythick=2,thick=1, $
                                median=median, diffuse=diffuse, nsum=ii, bg_nsum=bg_nsum,   $
                                XMARGIN=8,YMARGIN=4.5, oplot=oplot, $
                                NG_2nd_cal=NG_2nd_cal, $
                                error_new=error_new
           
        endfor

        ii=1
           ASCII = 'test.nsum='+ string(ii, format='(i0)')
           PNG   = 'test.nsum='+ string(ii, format='(i0)')
           plot_spec_with_image,wave_array,specimage_n_wc,mask_specimage_n,source_table,source_id,  $
                                root_dir=root_dir, offset_pix=offset_pix, no_mask=no_mask, with_image=with_image,  $
                                space_shift=space_shift, tvtop=tvtop, tvbottom=tvbottom, PS=PS, PNG=PNG, ascii=ascii, smooth_width=smooth_width, $
                                sigma_filter_set=sigma_filter_set, wc_mode=wc_mode, _EXTRA=EXTRA_KEYWORDS, $
                                specimage_wc_1d_smooth=specimage_wc_1d_smooth,specimage_fc_1d_smooth=specimage_fc_1d_smooth, $
                                no_wavelength_shift_error=no_wavelength_shift_error, $
                                title=title,subtitle=subtitle,charthick=2,charsize=2,xthick=2,ythick=2,thick=1, $
                                median=median, diffuse=diffuse, nsum=ii, bg_nsum=bg_nsum,   $
                                XMARGIN=8,YMARGIN=4.5, oplot=oplot, $
                                NG_2nd_cal=NG_2nd_cal, $
                                error_new=error_new
           

   ENDIF ELSE BEGIN
      plot_spec_with_image,wave_array,specimage_n_wc,mask_specimage_n,source_table,source_id,  $
                           root_dir=root_dir, offset_pix=offset_pix, no_mask=no_mask, with_image=with_image,  $
                           space_shift=space_shift, tvtop=tvtop, tvbottom=tvbottom, PS=PS, PNG=PNG, ascii=ascii, smooth_width=smooth_width, $
                           sigma_filter_set=sigma_filter_set, wc_mode=wc_mode, _EXTRA=EXTRA_KEYWORDS, $
                           specimage_wc_1d_smooth=specimage_wc_1d_smooth,specimage_fc_1d_smooth=specimage_fc_1d_smooth, $
                           no_wavelength_shift_error=no_wavelength_shift_error, $
                           title=title,subtitle=subtitle,charthick=1,charsize=2,xthick=2,ythick=2,thick=1, $
                           median=median, diffuse=diffuse, bg_nsum=bg_nsum,   $
                           XMARGIN=8,YMARGIN=4.5, oplot=oplot, $
                           NG_2nd_cal=NG_2nd_cal, $
                           error_new=error_new
   ENDELSE

ENDELSE     


end
