pro iispec_plot_auto, short=short

data_dir = getenv('IRC_SPECRED_DATADIR')

list_file = data_dir + 'list.txt'

;;; read ID number and AOT list
readcol, list_file, format='A,A,A,A', ID, subID, AOTpar1, AOTpar2,delimiter=',', COMMENT='#', /silent

ID    = long(ID)
subID = long(subID)

source_id = 0

;;; execute toolkit 
i=0
REPEAT BEGIN

;-----------------------------------------------------------------------------------------
;  output    
   print,'Output ASCII spectrum of ' + strtrim(string(ID[i]),2) + '.' + strtrim(string(subID[i]),2)

   for ii = -10, 10, 1 do begin
;;;   for ii = -20, 20, 1 do begin

      nsum = 9

      IF keyword_set(short) THEN BEGIN

         title_id = strtrim(string(ID[i]),2) + '.' + strtrim(string(subID[i]),2) + '.' + strtrim(string(source_id),2) + '  (space_shift=' + string(ii, format='(i+03)') + ')' + ' short'

         ASCII = 'test.space_shift='+ string(ii, format='(i+03)') + '.short'
         PNG   = 'test.space_shift='+ string(ii, format='(i+03)') + '.short'
         
         if AOTpar1[i] eq 'a' then begin
            iispec_plot, ID[i], subID[i], source_id,      /with_image, space_shift=ii, nsum=nsum, /med, PNG=PNG, ascii=ascii, title=title_id, /short
         endif

         if AOTpar1[i] eq 'b' then begin
            iispec_plot, ID[i], subID[i], source_id, /NG, /with_image, space_shift=ii, nsum=nsum, /med, PNG=PNG, ascii=ascii, title=title_id, /short
         endif

      ENDIF ELSE BEGIN

         title_id = strtrim(string(ID[i]),2) + '.' + strtrim(string(subID[i]),2) + '.' + strtrim(string(source_id),2) + '  (space_shift=' + string(ii, format='(i+03)') + ')'

         ASCII = 'test.space_shift='+ string(ii, format='(i+03)')
         PNG   = 'test.space_shift='+ string(ii, format='(i+03)')
         
         if AOTpar1[i] eq 'a' then begin
            iispec_plot, ID[i], subID[i], source_id,      /with_image, space_shift=ii, nsum=nsum, /med, PNG=PNG, ascii=ascii, title=title_id
         endif

         if AOTpar1[i] eq 'b' then begin
            iispec_plot, ID[i], subID[i], source_id, /NG, /with_image, space_shift=ii, nsum=nsum, /med, PNG=PNG, ascii=ascii, title=title_id
         endif

      ENDELSE

   endfor

   i=i+1

ENDREP UNTIL i EQ N_ELEMENTS(ID) 


END
